//***********************************************
//	FreeStuff Viewer
//	Shows the last 10 things listed at
//	freestuffcrazy.com
//
// 	Author: Christopher Wong
//	Date: 5/1/2005
//************************************************

var infoFader;
var upFader;
var downFader;
var frontstretcher;
var main;
var PREFSIZE = 76;
var FULLSIZE = 200;
var RELOADTIME = 1000*60*5;
var lastDate;
var flash;
var flasher;
var timer;
var savedOutput;

	
function DEBUG(str){
	var debugDiv;
	
	debugDiv = document.getElementById("debugDiv");
	debugDiv.appendChild(document.createTextNode(str));
	debugDiv.appendChild(document.createElement("br"));
	debugDiv.scrollTop = debugDiv.scrollHeight;
}

//setup everything
function setup(){
	//document.getElementById("debug").innerHTML = "hi";
	flash = false;
	lastDate = "ERROR";
	infoFader=new Fader(document.getElementById("flip"), null, 250);
	upFader=new Fader(document.getElementById("up"), null, 250);
	downFader=new Fader(document.getElementById("down"), null, 250);
	frontstretcher = new Stretcher(document.getElementById("front"), FULLSIZE, 500, '');
	prefstretcher = new Stretcher(document.getElementById("front"), PREFSIZE, 500, '');
	
	createGenericButton(document.getElementById("doneButton"), "Back", prefsDone, 67);
	
	scrollerInit(document.getElementById("myScrollBar"), document.getElementById("myScrollTrack"), document.getElementById("myScrollThumb"));
	
	main = document.getElementById("mainContent");

	main.style.width = "378px";
	document.getElementById("myScrollTrack").style.display = "block";
	mainContent.style.display = "block";	
	refreshData();
	calculateAndShowThumb(main);

	
	
	if(window.widget){
		widget.onshow = onshow;
    	widget.onhide = onhide;
	}
	
	timer = setInterval("refreshData();", RELOADTIME);
			

	
    window.onfocus = reloadData;
    //window.onblur = blur;
}

function updateFlash(){
	//DEBUG("flashing!");
	var className = document.getElementById("span0").className;
	
	if (!flash){
		
		document.getElementById("span0").className='fronttext';
		clearInterval(flasher);
		flasher == null;
	}
	else if(className =='fronttextflash'){
		document.getElementById("span0").className='fronttext';
	} 
	else {
		document.getElementById("span0").className='fronttextflash';
	}
	
	
}

function refreshData(){
	var d;
	d = new Date();
	DEBUG("refresh");
	xmlResponse = new XMLHttpRequest();
	xmlResponse.onreadystatechange = handleStateChange;
	xmlResponse.open("GET", "http://www.freestuffcrazy.com/widgetdata.php?id=" + d.getTime(), true);
	xmlResponse.send(null);
}

function handleStateChange(){
	var i;
	var d;
	var file;
	var output = document.createElement("div");
	output.setAttribute("class", "resultsDiv");

	if (xmlResponse.readyState == 4){
		if(xmlResponse.status == 200){
			response = xmlResponse.responseXML.documentElement;
			output = document.createElement("div");
			output.setAttribute("class", "resultsDiv");
			for( i = 0; i < response.getElementsByTagName('t').length; i++){
				output.appendChild (makeOutput(i,response.getElementsByTagName('t')[i].firstChild.data, response.getElementsByTagName('l')[i].firstChild.data));
				output.appendChild(document.createElement("br"));
			}

			
			if (frontstretcher.isStretched()) {
				//everything went fine output results

				lastDate = response.getElementsByTagName('u')[0].firstChild.data;
				savedOutput = output;
				if (main.firstChild) {
					main.removeChild(main.firstChild);
				} 
				main.appendChild(output);
				
			} else {
				DEBUG("newspan");
				var newDate = response.getElementsByTagName('u')[0].firstChild.data.toString();
				DEBUG(newDate + " " +lastDate);
				if(lastDate != newDate){
					DEBUG("flash");
					flash = true;
					
					flasher = setInterval("updateFlash();", 1000);
					lastDate = response.getElementsByTagName('u')[0].firstChild.data;

				} 
				 savedOutput = output;
			
				printMain("Last Update: " + lastDate);
			}

			calculateAndShowThumb(main);
			
			
		}
		else {
			//error
			if (main.firstChild) {
				main.removeChild(main.firstChild);
			} 
			main.appendChild(savedOutput);
			debugDiv.appendChild(document.createTextNode("error"));
			debugDiv.appendChild(document.createElement("br"));
			debugDiv.scrollTop = debugDiv.scrollHeight;
		}
	}
}

function makeOutput (num, title, url){
	var output =document.createElement("span");
	output.setAttribute("id", "span"+num);
	output.setAttribute("class", "fronttext");
	output.setAttribute("onMouseOver", "highlite('span"+num+"');");
	output.setAttribute("onMouseOut", "document.getElementById('span"+num + "').className='fronttext';");
	output.setAttribute("onClick",'window.widget.openURL("' +url+'");');
	output.innerHTML = title;

	return output;
}

function printMain(str){
	var newSpan = document.createElement("span");
	newSpan.setAttribute("id", "span0");
	newSpan.setAttribute("class", "fronttext");
	newSpan.setAttribute("onMouseOver", "highlite('span0');");
	newSpan.setAttribute("onMouseOut", "document.getElementById('span0').className='fronttext';");
	newSpan.setAttribute("onClick",'stretch();');
	newSpan.innerHTML = str;
	if (main.firstChild) {
		main.removeChild(main.firstChild);
	} 
	main.appendChild(newSpan);
	
	calculateAndShowThumb(main);
}


function prefsDone(){
	//save prefernces
	//go back to front
	//DEBUG("prefstretcher ");
	goToFront();
	printMain("Last Update: " + lastDate);
	//frontstretcher.maxPosition = frontstretcher.minPoshition + frontstretcher.stretchDistance;
}

function goToFront () {
	//DEBUG("goToFront");
	if (window.widget) {
		window.widget.prepareForTransition("ToFront");
	}
	
	// Set imageSelection from prefs.
	document.getElementById("back").style.display = "none";
	document.getElementById("front").style.display = "block";
	document.getElementById("up").style.display ="none";
	document.getElementById("down").style.display ="block";
	
	
	var stretcherTimeout = 800;
	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);  
	}

	if (prefstretcher.isStretched()) {
		// We stretched in order to show the prefs; shrink back when the front is shown
		//frontstretcher.onFinished = returnFrontState;
		prefstretcher.onFinished = refreshData;
		setTimeout("prefstretcher.stretch();", stretcherTimeout);  
	}

}




function flipClick (event) {

		//frontstretcher.onFinished = showBack;
		//frontstretcher.onFinished = refreshData;
		prefstretcher.onFinished = showBack;
		DEBUG("prefstretcher ");
		if(frontstretcher.isStretched()){
			frontstretcher.onFinished = preStretch;
			frontstretcher.stretch(event);
			
		} else {
			prefstretcher.stretch(event);
		}
}

function preStretch(){
	prefstretcher.onFinished = showBack;
	prefstretcher.stretch(event);
}

function stretch(){
	flash = false;
	frontstretcher.onFinished = refreshData;
	document.getElementById("upordown").style.display="none";
	if(!frontstretcher.isStretched()){
		document.getElementById("up").style.display="block";
		document.getElementById("down").style.display="none";
		printMain("Loading Free Stuff ....");
	} else {
		document.getElementById("up").style.display="none";
		document.getElementById("down").style.display="block";
		printMain("Last Update: " + lastDate);
	}
	frontstretcher.stretch();
}

function showBack(){
	if (window.widget) {
		window.widget.prepareForTransition("ToBack");
	}
	
	document.getElementById("fliprollie").style.display = "none";
	// get image selection from prefs; otherwise set 1.
	document.getElementById("front").style.display = "none";
	document.getElementById("back").style.display = "block";
	if (window.widget){
		setTimeout ('widget.performTransition();', 0);
	}
}


function highlite(name){
	document.getElementById(name).className='fronttexthighlite';
	//alert(document.getElementById(name).className);
}


function onshow () {
	
    if (timer == null) {
		refreshData();
        timer = setInterval("refreshData();", RELOADTIME);
    }
}
function onhide () {
    if (timer != null) {
        clearInterval(timer);
        timer = null;
    }
}

function fadeInfoButton() {
	
	if (!infoFader.fadingIn) {
		infoFader.startFade(infoFader.now, 0.5);
		infoFader.fadingIn = true;
	}
	if(!upFader.fadingIn){
		upFader.startFade(upFader.now, 0.5);
		upFader.fadingIn=true;
	}
	if(!downFader.fadingIn){
		downFader.startFade(downFader.now, 0.5);
		downFader.fadingIn=true;
	}
} 
function fadeOutInfoButton() {
	infoFader.fadeOut();
	upFader.fadeOut();
	downFader.fadeOut();

} 

/*
//Does nothing for now, maybe in the future
function focus()
{
    document.getElementById("lcd-backlight").style.visibility =  "block";
    document.getElementById("calcDisplay").setAttribute("class", "backlightLCD");
}

function blur()
{
    document.getElementById("lcd-backlight").style.visibility = "none";
    document.getElementById("calcDisplay").setAttribute("class", "nobacklightLCD");
}
*/


function showPrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    front.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

//INFO Button Code
var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}


